﻿Type=Class
Version=2.52
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Public AsView As Panel 'for adding to the display
	Private myManager As cHTabManager 'if set, manager will be where the "MyTab" goes
	
	Private vModule As Object
	Private vActivity As Activity
	Private imgBMP As ImageView 'to hold the bitmap if there
	Private bmpWidth As Int
	Private bmpHeight As Int
	Private lblText As Label
	
	Private animspeed As Long
	
	Private animPlusIn As AnimationPlus
	Private animPlusOut As AnimationPlus
	
	Private myTab As Panel	'will be the 'Tab' that gets clicked on to make it appear
	Private itabTop As Int
	Private itabBottom As Int
	Private itabWidth As Int
	Private iTabTextColor As Int
	Private iTabColor As Int
	Private strTabText As String
	Private bRightSide As Boolean
	
	Private itabMode As Int
	Public tabMode_Square = 1
	Public tabMode_Trapezoid = 2
	Public tabMode_Ellipse = 3
	
	Public animSpeed_Fast = 500
	Public animspeed_Med = 1000
	Public animspeed_Slow = 1500
	
	
	
End Sub

'if no picture send "" , if no tabText send "" (Pick one, if both sent, only pic will be displayed)
'if text is sent, if tabHeight > tabWidth then text displaye vertical, else horizontal
'tabPicture must be in File.DirAssests
'default tabMode is trapezoid, tabColor is opaque, tabText is Black
'tabTop and tabBottom are where the tab should be displayed
'tabThickness is how thick the base should be from the edge of the device
'when adding AsView, make it's dimensions whatever you want, just ensure
'that it is where you want it to be heightwise, as that will be where it slides
'in and out.
'if OnRight set, then tab will be on right side of screen
Public Sub Initialize(callingActivity As Activity, callingModule As Object, tabPictureFileName As String, _
									tabText As String, tabTop As Int, tabBottom As Int, tabWidth As Int, OnRight As Boolean)

	itabMode = tabMode_Trapezoid
	vActivity = callingActivity
	vModule = callingModule
	AsView.Initialize("AsView")
	iTabColor = Colors.ARGB(30, 255, 255, 255)
	iTabTextColor = Colors.Black
	itabWidth = tabWidth
	itabTop = tabTop
	itabBottom = tabBottom
	If tabPictureFileName <> "" Then
		If File.Exists(File.DirAssets, tabPictureFileName) Then
			Dim bp As BitmapPlus
			Dim bmpDimensions As Map
			File.Copy(File.DirAssets, tabPictureFileName, File.DirInternalCache, tabPictureFileName)
			Dim aString As String
			aString = File.DirAssets
			bmpDimensions = bp.GetImageDimensions(File.DirInternalCache & "/" & tabPictureFileName)
			Dim width, height As Int
			width = bmpDimensions.GetValueAt(1)
			height = bmpDimensions.GetValueAt(0)
			imgBMP.Initialize("myTab")
			
			bmpWidth = tabWidth - 2dip
			bmpHeight = height*(tabWidth-2dip)/width
			
			imgBMP.Bitmap = LoadBitmapSample(File.DirAssets, tabPictureFileName, bmpWidth, bmpHeight)
			imgBMP.Gravity = Gravity.FILL
		Else
			Msgbox("no picture loaded for TabPanel, no file exists", "No Pic")
		End If
	Else If tabText <> "" Then
		lblText.Initialize("myTab")
		lblText.Color = iTabColor
		lblText.TextColor = Colors.Black
		lblText.Text = tabText
	Else
		Msgbox("No text or picture sent to a cHTabPanel during initialization", "No Text or Pic")
	End If
	
	
	animspeed = animspeed_Med
	bRightSide = OnRight
	
	
End Sub


'sets the tab color
Public Sub setTabColor(newColor As Int)
	iTabColor = newColor
	If myTab.IsInitialized Then
		myTab.Color = newColor
	End If
End Sub

'sets the tab TextColor
Public Sub setTabTextColor(newColor As Int)
	iTabTextColor = newColor
	If lblText.IsInitialized Then
		lblText.TextColor = newColor
	End If
End Sub

'programatically open the panel
Public Sub OpenPanel(useAnimation As Boolean)


End Sub

'programatically close the panel
Public Sub ClosePanel(useAnimation As Boolean)


End Sub

'used to finalize and start the TabPanel
Public Sub StartTabPanel
'panel will be sent to its hiding spot
'mytab wil be created and any text or pic added
If Not(myManager.IsInitialized) Then

	'Try
		If bRightSide Then
			AsView.Left = vActivity.Width
		Else
			AsView.Left = vActivity.Left - AsView.Width
		End If
		myTab.Initialize("myTab")
		
		If bRightSide Then
			vActivity.AddView(myTab, vActivity.Width - itabWidth, itabTop, itabWidth, itabBottom - itabTop)
		Else
			vActivity.AddView(myTab, vActivity.Left, itabTop, itabWidth, itabBottom - itabTop)
		End If
		

		If imgBMP.IsInitialized Then
			myTab.AddView(imgBMP, 1dip, ((itabBottom-itabTop)-bmpHeight)/2, bmpWidth, bmpHeight)
		Else
			'this means add a label
			
			If (itabBottom - itabTop) > itabWidth Then 'text goes vertical
			
			
			Else 'text goes horizontal
			
			
			End If
			lblText.TextColor = iTabTextColor
			lblText.Color = iTabColor
		End If
		
		Dim tempWidth As Int
		tempWidth = vActivity.Width
		
		If bRightSide Then
			animPlusIn.InitializeTranslate("animIn", tempWidth - AsView.Width, AsView.Top, tempWidth, AsView.Top)
			animPlusOut.InitializeTranslate("animOut", tempWidth - 1dip , AsView.Top, tempWidth - AsView.Width, AsView.Top)
		Else
			animPlusIn.InitializeTranslate("animIn", AsView.Width, AsView.Top, -AsView.Width, AsView.Top)
			animPlusOut.InitializeTranslate("animOut", -AsView.Width, AsView.Top, AsView.Width, AsView.Top)
		End If
		
		animPlusIn.Duration = animspeed
		animPlusOut.Duration = animspeed
		animPlusOut.SetInterpolator(animPlusOut.INTERPOLATOR_LINEAR)
		animPlusIn.SetInterpolator(animPlusIn.INTERPOLATOR_LINEAR)
		myTab.Color = iTabColor
		
'	Catch
'		Msgbox("It appears that the AsView for an HTabPanel isn't loaded", "Not Loaded")
'	End Try

Else
	'code here to add to manager

End If

End Sub

Private Sub myTab_Click
	AsView.BringToFront
	Log(AsView.Left)
	Log(AsView.Top)
	
	If animPlusIn.IsInitialized Then
		animPlusIn.Stop(AsView)
		vActivity.Invalidate
	End If
	
	If animPlusOut.IsInitialized Then
		animPlusOut.Stop(AsView)
		vActivity.Invalidate
	End If
	
	If bRightSide Then

		
		If AsView.Left >= vActivity.Width Then
			AsView.Left = 0
			vActivity.Invalidate
			
			animPlusOut.Start(AsView)
			animPlusOut.Start(myTab)
		'	AsView.Left = vActivity.Width - AsView.Width
		Else
			animPlusIn.Start(AsView)
			myTab.Visible = False
		End If
	Else
		If (AsView.Left+AsView.Width) <= vActivity.Left Then
			animPlusOut.Start(AsView)
		Else
			animPlusIn.Start(AsView)
		End If

	End If

End Sub


'use to set animation speed
Public Sub setAnimationSpeed(newTime As Long)
If animPlusIn.IsInitialized Then
	animPlusIn.Duration = newTime
End If
animspeed = newTime
End Sub

animPlusIn

Private Sub animOut_AnimationEnd
If bRightSide Then
	AsView.Left = vActivity.Width - AsView.Width
	myTab.Left = AsView.Left - myTab.Width
End If
End Sub

Private Sub animIn_AnimationEnd
If bRightSide Then
	AsView.Left = vActivity.Width
	myTab.Left = vActivity.Width - myTab.Width
	myTab.Visible = True
End If

End Sub